e__fpu_off:
	moveq	#_FLG_FPU|_FLG_IOFPU,d0
	not.b	d0
	and.b	__ohavefpu(opc),d0
	move.b	d0,__havefpu
	ric	d0

e__fpu_on:
	moveq	#0,d0
	move.b	__ohavefpu(opc),d0
	move.b	d0,__havefpu
	ric	d0

e__fpuinit:
	jbsr	__fpuinit
	rvc

e__is68881:
	jbsr	__is68881
	ric	d0

e__iscopro:
	jbsr	__iscopro
	ric	d0

e_asin:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_asin
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,asin_edom_mes
9:	rff	d0,d1,d2,asin_erange_mes

e_asinh:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_asinh
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,asinh_edom_mes
9:	rff	d0,d1,d2,asinh_erange_mes

e_acos:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_acos
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,acos_edom_mes
9:	rff	d0,d1,d2,acos_erange_mes

e_acosh:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_acosh
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,acosh_edom_mes
9:	rff	d0,d1,d2,acosh_erange_mes

e_atan:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_atan
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,atan_edom_mes
9:	rff	d0,d1,d2,atan_erange_mes

e_atan2:
	clr.l	_errno
	move.l	par2f+4(sp),-(sp)
	move.l	4+par2f(sp),-(sp)
	move.l	8+par1f+4(sp),-(sp)
	move.l	12+par1f(sp),-(sp)
	jbsr	_atan2
	lea	16(sp),sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,atan2_edom_mes
9:	rff	d0,d1,d2,atan2_erange_mes

e_atanh:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_atanh
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,atanh_edom_mes
9:	rff	d0,d1,d2,atanh_erange_mes

e_ceil:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_ceil
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,ceil_edom_mes
9:	rff	d0,d1,d2,ceil_erange_mes

e_cos:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_cos
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,cos_edom_mes
9:	cmpi.l	#ERANGE,d2
	bne	9f
	rff	d0,d1,d2,cos_erange_mes
9:	rff	d0,d2,d2,cos_eothers_mes

e_cosh:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_cosh
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,cosh_edom_mes
9:	cmpi.l	#ERANGE,d2
	bne	9f
	rff	d0,d1,d2,cosh_erange_mes
9:	rff	d0,d2,d2,cosh_eothers_mes

e_exp:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_exp
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,exp_edom_mes
9:	cmpi.l	#ERANGE,d2
	bne	9f
	rff	d0,d1,d2,exp_erange_mes
9:	rff	d0,d2,d2,exp_eothers_mes

e_fabs:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_fabs
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,fabs_edom_mes
9:	rff	d0,d1,d2,fabs_erange_mes

e_floor:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_floor
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,floor_edom_mes
9:	rff	d0,d1,d2,floor_erange_mes

e_fmod:
	clr.l	_errno
	move.l	par2f+4(sp),-(sp)
	move.l	4+par2f(sp),-(sp)
	move.l	8+par1f+4(sp),-(sp)
	move.l	12+par1f(sp),-(sp)
	jbsr	_fmod
	lea	16(sp),sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,fmod_edom_mes
9:	rff	d0,d1,d2,fmod_erange_mes

e_frexp:
	clr.l	_errno
	move.l	par2vp(sp),-(sp)
	move.l	4+par1f+4(sp),-(sp)
	move.l	8+par1f(sp),-(sp)
	jbsr	_frexp
	lea	12(sp),sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,frexp_edom_mes
9:	rff	d0,d1,d2,frexp_erange_mes

e_isinf:
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_isinf
	addq.l	#8,sp
	ric	d0

e_isnan:
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_isnan
	addq.l	#8,sp
	ric	d0

e_ldexp:
	clr.l	_errno
	move.l	par2vp(sp),-(sp)
	move.l	4+par1f+4(sp),-(sp)
	move.l	8+par1f(sp),-(sp)
	jbsr	_ldexp
	lea	12(sp),sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,ldexp_edom_mes
9:	cmpi.l	#ERANGE,d2
	bne	9f
	rff	d0,d1,d2,ldexp_erange_mes
9:	rff	d0,d1,d2,ldexp_eothers_mes

e_log:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_log
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,log_edom_mes
9:	cmpi.l	#ERANGE,d2
	bne	9f
	rff	d0,d1,d2,log_erange_mes
9:	rff	d0,d1,d2,log_eothers_mes

e_log10:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_log10
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,log10_edom_mes
9:	cmpi.l	#ERANGE,d2
	bne	9f
	rff	d0,d1,d2,log10_erange_mes
9:	rff	d0,d1,d2,log10_eothers_mes

e_modf:
	clr.l	_errno
	move.l	par2vp(sp),-(sp)
	move.l	4+par1f+4(sp),-(sp)
	move.l	8+par1f(sp),-(sp)
	jbsr	_modf
	lea	12(sp),sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,modf_edom_mes
9:	rff	d0,d1,d2,modf_erange_mes

e_pow:
	clr.l	_errno
	move.l	par2f+4(sp),-(sp)
	move.l	4+par2f(sp),-(sp)
	move.l	8+par1f+4(sp),-(sp)
	move.l	12+par1f(sp),-(sp)
	jbsr	_pow
	lea	16(sp),sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,pow_edom_mes
9:	rff	d0,d1,d2,pow_erange_mes

e_sin:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_sin
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,sin_edom_mes
9:	cmpi.l	#ERANGE,d2
	bne	9f
	rff	d0,d1,d2,sin_erange_mes
9:	rff	d0,d1,d2,sin_eothers_mes

e_sinh:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_sinh
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,sinh_edom_mes
9:	cmpi.l	#ERANGE,d2
	bne	9f
	rff	d0,d1,d2,sinh_erange_mes
9:	rff	d0,d1,d2,sinh_eothers_mes

e_sqrt:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_sqrt
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,sqrt_edom_mes
9:	rff	d0,d1,d2,sqrt_erange_mes

e_tan:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_tan
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,tan_edom_mes
9:	cmpi.l	#ERANGE,d2
	bne	9f
	rff	d0,d1,d2,tan_erange_mes
9:	rff	d0,d1,d2,tan_eothers_mes

e_tanh:
	clr.l	_errno
	move.l	par1f+4(sp),-(sp)
	move.l	4+par1f(sp),-(sp)
	jbsr	_tanh
	addq.l	#8,sp
	move.l	_errno(opc),d2
	bne	9f
	rfc	d0,d1
9:	cmpi.l	#EDOM,d2
	bne	9f
	rff	d0,d1,d2,tanh_edom_mes
9:	rff	d0,d1,d2,tanh_erange_mes
